Index: src/perl/register-dataset.cgi
===================================================================
--- src/perl/register-dataset.cgi	(revision 3472)
+++ src/perl/register-dataset.cgi	(revision 3473)
@@ -177,6 +177,9 @@
     $nceas_db_password = $config->nceas_db_password();
 }
 my $debug = $config->debug();
+if ($FORM::debug) {
+    $debug = $FORM::debug;
+}
 my $lat = $config->get('lat');
 my $lon = $config->get('lon');
 
@@ -196,7 +199,8 @@
 my $ttConfig = {
              INCLUDE_PATH => $templatesdir, 
              INTERPOLATE  => 0,                    
-             POST_CHOMP   => 1,                   
+             POST_CHOMP   => 1,
+             #DEBUG        => 'all',
              };
 
 # create an instance of the template processor
@@ -226,9 +230,8 @@
 if (!hasContent($metacatUrl)) {
     debug("Registry: No Metacat.");
     print "Content-type: text/html\n\n";
-    $$templateVars{'message'} = 'Error: Metacat is not initialized! Make sure' . 
+    'Registry Error: Metacat is not initialized! Make sure' .
         ' MetacatUrl is set correctly in ' .  $FORM::cfg . '.cfg';
-    $template->process( $loginFormTemplate, $templateVars);
     exit(0);
 }
 
@@ -573,6 +576,14 @@
 } else {
     $$templateVars{'docid'} = $docid;
     $$templateVars{'cfg'} = $FORM::cfg;
+    # delete the remaining file objects from disk
+    for (my $fileNum = 0; $fileNum <= $FORM::upCount; $fileNum++) {
+        my $fn = 'uploadname_' . $fileNum;
+        if (hasContent(param($fn))) {
+            deleteFile(param($fn));
+        }
+    }
+    
 }
 
 #if (! $error) {
@@ -750,11 +761,11 @@
 	#}
     }
 
-    if (hasContent($FORM::beginningYear) && !($FORM::beginningYear =~ /[0-9][0-9][0-9][0-9]/)){
+    if (hasContent($FORM::beginningYear) && !($FORM::beginningYear =~ /[0-9]{4}/)){
 	push(@invalidParams, "Invalid year of start date specified.")
     }
 
-    if (hasContent($FORM::endingYear) && !($FORM::endingYear =~ /[0-9][0-9][0-9][0-9]/)){
+    if (hasContent($FORM::endingYear) && !($FORM::endingYear =~ /[0-9]{4}/)){
 	push(@invalidParams, "Invalid year of stop date specified.")
     }
     
@@ -1141,6 +1152,21 @@
     return ($outputName, $digest);
 }
 
+sub deleteFile {
+    my $input = shift;
+    my $fileName = $tmpdir . "/" . $input;
+
+    if (-e $fileName) {
+        unlink $fileName or
+            debug("Registry: failed to delete file $fileName.");
+    } else {
+        debug("Registry: unable to find file $fileName");
+    }
+    if (!-e $fileName) {
+        debug("Registry: successfully deleted $fileName");
+    }
+}
+
 sub uploadData {
     my $data = shift;
     my $docid = shift;
@@ -1240,7 +1266,7 @@
     foreach my $origName (param()) {
         my $origNum = $origName;
         $origNum =~ s/origNamelast//; # get the index of the parameter 0 to 10
-        if ( $origNum =~ /^([0-9])$/) {
+        if ( $origNum =~ /^([0-9]+)$/) {
             # do not generate EML for empty originator fields
             if (hasContent(param("origNamefirst" . $origNum))) {
                 my $first = normalize(param("origNamefirst" . $origNum));
@@ -1355,7 +1381,7 @@
     foreach my $kwName (param()) {
         my $kwNum = $kwName;
         $kwNum =~ s/keyword//; # get the index of the parameter 0, ..., 10
-        if ( $kwNum =~ /^([0-9])$/ ){
+        if ( $kwNum =~ /^([0-9]+)$/ ){
             # don't generate xml for empty keyword fields
             # don't generate taxonomic keyword fields, those go in taxonomic coverage
             if (hasContent(param($kwName))) {
@@ -1538,8 +1564,7 @@
 
     if (hasContent($FORM::origDeliveryContact) ||
         hasContent($FORM::origCityContact) ||
-        (hasContent($FORM::origStateContact) &&
-        ($FORM::origStateContact !~ "Select state here.")) ||
+        hasContent($FORM::origStateContact)  ||
         hasContent($FORM::origStateOtherContact) ||
         hasContent($FORM::origZIPContact) ||
         hasContent($FORM::origCountryContact)) {
@@ -1552,7 +1577,7 @@
             $cont .= "<city>".normalize($FORM::origCityContact)."</city>\n";
         }
         if (hasContent($FORM::origStateContact) &&
-            ($FORM::origStateContact !~ "Select state here.")) {
+            ($FORM::origStateContact !=~ /select state/i)) {
             $cont .= "<administrativeArea>".normalize($FORM::origStateContact);
             $cont .= "</administrativeArea>\n";
         } elsif (hasContent($FORM::origStateOtherContact)) {
@@ -1740,7 +1765,7 @@
             my $taxIndex = $trn;
             $taxIndex =~ s/taxonRankName//; # get the index of the parameter 0, ..., 10
             my $trv = "taxonRankValue".$taxIndex;
-            if ( $taxIndex =~ /[0-9]/ ){
+            if ( $taxIndex =~ /[0-9]+/ ){
                 if (hasContent(param($trn)) && hasContent(param($trv))) {
                     if (! $foundFirstTaxon) {
                         $cov .= "<taxonomicCoverage>\n";
@@ -3654,7 +3679,6 @@
     	}
     }
 
-
     $$templateVars{'providerGivenName'} = normalizeCD($FORM::providerGivenName);
     $$templateVars{'providerSurName'} = normalizeCD($FORM::providerSurName);
     if($FORM::site eq "Select your station here."){
@@ -3670,12 +3694,11 @@
     $$templateVars{'origNamefirst0'} = normalizeCD($FORM::origNamefirst0);
     $$templateVars{'origNamelast0'} = normalizeCD($FORM::origNamelast0);
     $$templateVars{'origNameOrg'} = normalizeCD($FORM::origNameOrg);
-    # $$templateVars{'origRole0'} = $FORM::origRole0;
     $$templateVars{'origDelivery'} = normalizeCD($FORM::origDelivery);
     $$templateVars{'origCity'} = normalizeCD($FORM::origCity);
-    if($FORM::origState eq "Select State Here."){
+    if ($FORM::origState =~ /select state/i) {
         $$templateVars{'origState'} = "";
-    }else{
+    } else {
         $$templateVars{'origState'} = $FORM::origState;
     }
     $$templateVars{'origStateOther'} = normalizeCD($FORM::origStateOther);
@@ -3686,12 +3709,13 @@
     $$templateVars{'origEmail'} = normalizeCD($FORM::origEmail);
     $$templateVars{'useOrigAddress'} = normalizeCD($FORM::useOrigAddress);
     if($FORM::useOrigAddress eq "on"){
+      
         $$templateVars{'origNamefirstContact'} = normalizeCD($FORM::origNamefirst0);
         $$templateVars{'origNamelastContact'} = normalizeCD($FORM::origNamelast0);
         $$templateVars{'origNameOrgContact'} = normalizeCD($FORM::origNameOrg);
         $$templateVars{'origDeliveryContact'} = normalizeCD($FORM::origDelivery); 
         $$templateVars{'origCityContact'} = normalizeCD($FORM::origCity);
-        if($FORM::origState eq "Select State Here."){
+        if($FORM::origState =~ /select state/i){
         $$templateVars{'origStateContact'} = "";
         }else{
         $$templateVars{'origStateContact'} = $FORM::origState;
@@ -3708,7 +3732,7 @@
         $$templateVars{'origNameOrgContact'} = normalizeCD($FORM::origNameOrgContact);
         $$templateVars{'origDeliveryContact'} = normalizeCD($FORM::origDeliveryContact); 
         $$templateVars{'origCityContact'} = normalizeCD($FORM::origCityContact);
-        if($FORM::origStateContact eq "Select State Here."){
+        if($FORM::origStateContact =~ /select state/i){
         $$templateVars{'origStateContact'} = "";
         }else{
         $$templateVars{'origStateContact'} = $FORM::origStateContact;
@@ -3735,7 +3759,7 @@
             $$templateVars{"origNamelast".$aoCount} = normalizeCD($aoLNArray->[$i]);
             $$templateVars{"origRole".$aoCount} = normalizeCD($aoRoleArray->[$i]);
             $aoCount++;
-	}    
+        }    
     }
 
     $$templateVars{'aoCount'} = $aoCount;
@@ -3811,17 +3835,22 @@
 
     $$templateVars{'taxaCount'} = $taxonCount-1;
     $$templateVars{'taxaAuth'} = normalizeCD($FORM::taxaAuth);
-
+    my $deleteCount = 0;
     for (my $upNum = 0; $upNum <= $FORM::upCount; $upNum++) {
         my $upn = "upload_$upNum";
         if (hasContent(param($upn))) {
-            debug("Registry: processing existing file: $upn");
-            $$templateVars{"upload_$upNum"} = param("upload_$upNum");
-            $$templateVars{"uploadname_$upNum"} = param("uploadname_$upNum");
-            $$templateVars{"uploadtype_$upNum"} = param("uploadtype_$upNum");
+            if (grep {$_ eq ("uploadname_$upNum")} @FORM::deletefile) {
+                deleteFile(param("uploadname_$upNum"));
+                $deleteCount++;
+            } else {
+                debug("Registry: processing existing file: $upn");
+                $$templateVars{"upload_$upNum"} = param("upload_$upNum");
+                $$templateVars{"uploadname_$upNum"} = param("uploadname_$upNum");
+                $$templateVars{"uploadtype_$upNum"} = param("uploadtype_$upNum");
+            }
         }
     }
-
+    
     my $uploadCount = 0;
     for (my $fileNum = 0; $fileNum <= $FORM::fileCount; $fileNum++) {
         my $fn = 'file_' . $fileNum;
@@ -3839,7 +3868,8 @@
             $uploadCount++;
         }
     }
-    $$templateVars{'upCount'} = $uploadCount + $FORM::upCount;
+    # total uploads are: new uploads - deleted files + original uploads
+    $$templateVars{'upCount'} = $uploadCount - $deleteCount + $FORM::upCount;
     $$templateVars{'methodTitle'} = normalizeCD($FORM::methodTitle);
  
     my @tempMethodPara;
@@ -3934,7 +3964,6 @@
     $$templateVars{'origNamefirst0'} = $FORM::origNamefirst0;
     $$templateVars{'origNamelast0'} = $FORM::origNamelast0;
     $$templateVars{'origNameOrg'} = $FORM::origNameOrg;
- #   $$templateVars{'origRole0'} = $FORM::origRole0;
     $$templateVars{'origDelivery'} = $FORM::origDelivery;
     $$templateVars{'origCity'} = $FORM::origCity;
     $$templateVars{'origState'} = $FORM::origState;
@@ -3969,7 +3998,7 @@
 	    $origNameIndex =~ s/origNamefirst//; # get the index of the parameter 0, ..., 10
 	    my $origNamelast = "origNamelast".$origNameIndex;
 	    my $origRole = "origRole".$origNameIndex;
-	    if ( $origNameIndex =~ /[0-9]/  && $origNameIndex > 0){
+	    if ( $origNameIndex =~ /[0-9]+/  && $origNameIndex > 0){
 		if (hasContent(param($origName)) && hasContent(param($origNamelast)) && hasContent(param($origRole))) {
 		    debug("Registry processing keyword: $origName = ".param($origName)." $origNamelast = ".param($origNamelast)." $origRole = ".param($origRole));
 		    $$templateVars{$origName} = normalizeCD(param($origName));
@@ -3988,7 +4017,7 @@
 	    $keyIndex =~ s/keyword//; # get the index of the parameter 0, ..., 10
 	    my $keyType = "kwType".$keyIndex;
 	    my $keyTh = "kwTh".$keyIndex;
-	    if ( $keyIndex =~ /[0-9]/ ){
+	    if ( $keyIndex =~ /[0-9]+/ ){
 		if (hasContent(param($kyd)) && hasContent(param($keyType)) && hasContent(param($keyTh))) {
 		    debug("Registry processing keyword: $kyd = ".param($kyd)." $keyType = ".param($keyType)." $keyTh = ".param($keyTh));
 		    $$templateVars{$kyd} = param($kyd); 
@@ -4040,7 +4069,7 @@
             my $taxIndex = $trn;
             $taxIndex =~ s/taxonRankName//; # get the index of the parameter 0, ..., 10
             my $trv = "taxonRankValue".$taxIndex;
-            if ( $taxIndex =~ /[0-9]/ ){
+            if ( $taxIndex =~ /[0-9]+/ ){
                 if (hasContent(param($trn)) && hasContent(param($trv))) {
                     debug("Registry processing taxon: $trn = ".param($trn)." $trv = ".param($trv));
                     $$templateVars{$trn} = param($trn);
@@ -4073,7 +4102,7 @@
         if ($upload =~ /upload_/) {
             my $fileIndex = $upload;
             $fileIndex =~ s/upload_//;
-            if ( $fileIndex =~ /[0-9]/ ) {
+            if ( $fileIndex =~ /[0-9]+/ ) {
                 if (hasContent(param($upload))) {
                     debug("Registry: returning filename: " . param($upload));
                     $$templateVars{"upload_$fileIndex"} = param($upload);
